using UnityEngine;
using System.Collections;

[RequireComponent(typeof(Camera))]
public class LightCamera : MonoBehaviour {
	//public Camera MainCamera;
	public Shader ReplacementShader;
	public float AlphaCutoff;
	public RenderTexture TargetTexture;
	public RenderTexture RenderTex;
	public Material LightMaterial;
	public int LightTextureResolution = 256;
	public float LightTexturePowerFunction = 1.0f;
	public float LightTextureScaling = 1.0f;

	public int PixelSize = 3;

	private Texture2D PointLightTexture;
	private Camera thisCamera;
	// Use this for initialization

	void Start () {

		RenderTex.width = Screen.width / PixelSize;
		RenderTex.height = Screen.height / PixelSize;

		if ( TargetTexture != null ) {
			TargetTexture.width = Screen.width / PixelSize;
			TargetTexture.height = Screen.height / PixelSize;

			Shader.SetGlobalTexture( "_LightTex", TargetTexture );
		}
		thisCamera = gameObject.GetComponent<Camera>();
		//int mask = thisCamera.cullingMask;

		
		//ReplacementShader
		

		//thisCamera.CopyFrom(MainCamera);
		//thisCamera.cullingMask = mask;
		//thisCamera.targetTexture = TargetTexture;
		//thisCamera.SetReplacementShader(ReplacementShader, "");

		PointLightTexture = Util.TextureUtil.MakeAttenuationTexture(LightTextureResolution, LightTexturePowerFunction, LightTextureScaling);
		PointLightTexture.filterMode = FilterMode.Point;
		LightMaterial.mainTexture = PointLightTexture;
		LightMaterial.mainTextureScale = new Vector2( 0.7f, 0.7f );
		LightMaterial.mainTextureOffset = new Vector2( 0.15f, 0.15f );
		//LightMaterial.mainTextureScale = new Vector2( 1.0f, 1.0f );
		//LightMaterial.mainTextureOffset = new Vector2( 0.0f, 0.0f );
		
	}
	
	//Flipper[] objs;
	
	void OnPreCull() {
		//Debug.Log("precul");
        /*camera.ResetWorldToCameraMatrix();
        camera.ResetProjectionMatrix();
        camera.projectionMatrix = camera.projectionMatrix * Matrix4x4.Scale(new Vector3(1, -1, 1));*/
		
		//objs = (Flipper[])FindObjectsOfType(typeof(Flipper));
		//foreach(Flipper o in objs) {
			//o.Flip ();
		//}
    }
	
    void OnPreRender() {
		
		//Debug.Log("prerender");
        //GL.SetRevertBackfacing(true);
    }
	
    void OnPostRender() {
		
		//Debug.Log("postrender");
        //GL.SetRevertBackfacing(false);
		
		//foreach(Flipper o in objs) {
			//o.Flip ();
		//}
    }
	
	// Update is called once per frame
	void Update () {
	
	}
}
