using UnityEngine;
using System.Collections;

public class TestOverlay : MonoBehaviour {
	public Material OverlayMaterial;
	private Texture2D mosaicTexture;

	public int PixelSize = 3;
	// Use this for initialization
	void Start () {
		//mosaicTexture = Util.TextureUtil.MakeMosaic(3, 0, 255);
		mosaicTexture = Util.TextureUtil.MakeMosaic3(PixelSize);
		
		mosaicTexture.filterMode = FilterMode.Point;
		OverlayMaterial.mainTexture = mosaicTexture;
		//OverlayMaterial.mainTextureScale = new Vector2(Screen.width/2, -Screen.height/2);  //hardcoded scales atm
		OverlayMaterial.mainTextureScale = new Vector2( Screen.width / PixelSize, -Screen.height / PixelSize );

		ScreenOverlay s = this.gameObject.GetComponent<ScreenOverlay>();
		//s.tiling = new Vector4(Screen.height / 2, -Screen.width / 2, 0.5f/Screen.width, 0.5f/Screen.height);

		float w = Screen.width / PixelSize;
		float h = Screen.height / PixelSize;

		//s.tiling = new Vector4(0, Screen.height / 3, 0.5f/Screen.width, 0.5f/Screen.height);
		//s.tiling = new Vector4( w, h, 1.0f / Screen.width, 1.0f / Screen.height );
		//s.tiling = new Vector4( w, h, 0, 0 );
		//s.tiling = new Vector4( w, h, 0.5f / Screen.width, 0.5f / Screen.height );
		//s.tiling = new Vector4( w, h, -1.5f / (float)Screen.width, 0.5f / (float)Screen.height );
		//s.tiling = new Vector4( w, h, -0.45f, -0.275f );
		//s.tiling = new Vector4( w, h, -0.5f, -0.5f );

		s.tiling = new Vector4( w, h/2, -0.5f, -0.5f );

		//s.tiling = new Vector4( w, h, 10, 0.5f / Screen.height );
		//s.tiling = new Vector4( Screen.width / 6, Screen.height / 6, 0.5f / Screen.width, 0.5f / Screen.height );
		s.texture = mosaicTexture;
	}
	
	// Update is called once per frame
	void Update () {
	
	}
}
