using UnityEngine;
using System.Collections;

namespace Util
{
	public class TextureUtil
	{

		/*public static Texture2D MakeScanline(int colcol:Int, h:Int) {
			var bd = new BitmapData(h,h, false, 0x808080);
			for(x in 0...h)
				bd.setPixel(x, h-1, col);
			return bd;
		}*/

		public static Texture2D MakeMosaic(float ww, byte black, byte white)
		{
			var wid = (int)ww;
			var bd = new Color32[wid * wid];
			for (int i = 0; i < bd.Length; i++)
			{
				bd[i] = new Color32(128, 128, 128, 255);
				//bd[i] = new Color(1, 0, 0);
			}

			//var w = Color.addAlphaChannel(0xE0E0E0, Std.int(white*255));
			var w = new Color32(224, 224, 224, white);
			var b = new Color32(0, 0, 0, black);

			bd[0] = w;
			bd[wid - 1 + wid * (wid - 1)] = b;
			for (int x = 1; x < (wid - 1); x++)
			{
				bd[x] = w;
				bd[x + wid * (wid - 1)] = b;
			}
			w = new Color32(1, 1, 1, white);
			for (int y = 1; y < (wid - 1); y++)
			{
				bd[0 + y * wid] = w;
				bd[(wid - 1) + wid * y] = b;
			}
			Texture2D newTexture = new Texture2D(wid, wid);
			newTexture.SetPixels32(bd);
			newTexture.wrapMode = TextureWrapMode.Repeat;
			newTexture.Apply();
			return newTexture;
		}

		//public static int addAlphaChannel(int c) {
		//    int a=255;
		//    return a << 24 | c;
		//}
		public static Texture2D MakeMosaic2(float ww) {
			Color32 col = Color.white;
			//float alpha = 1.0f;
			var wid = (int)ww;
			var bd = new Color32[wid * wid];
			for (int i=0; i<bd.Length; i++){
				//bd[i] = new Color(128.0f/255.0f, 128.0f/255.0f, 128.0f/255.0f, 1.0f);
				bd[i] = new Color32(128, 128, 128, 255);
			}
		
			//var w = Color.addAlphaChannel(col, Std.int(alpha*255));
			Color32 w = new Color(col.r, col.g, col.b, col.a);
		
			for(int x=1; x<(wid-1); x++){
				bd[x] = w;
			}

			Texture2D newTexture = new Texture2D(wid, wid);
			newTexture.SetPixels32(bd);
			newTexture.wrapMode = TextureWrapMode.Repeat;
			newTexture.Apply();
			return newTexture;
		}

		public static Texture2D MakeMosaic4(float ww)
		{
			Color32 col = Color.white;
			//float alpha = 1.0f;
			var wid = (int)ww;
			var bd = new Color32[wid * wid];
			for (int i = 0; i < bd.Length; i++)
			{
				//bd[i] = new Color(128.0f/255.0f, 128.0f/255.0f, 128.0f/255.0f, 1.0f);
				bd[i] = new Color32(128, 128, 128, 255);
			}

			//var w = Color.addAlphaChannel(col, Std.int(alpha*255));
			Color32 w = new Color(col.r, col.g, col.b, col.a);

			for (int x = 1; x < (wid - 1); x++)
			{
				bd[x] = w;
			}

			Texture2D newTexture = new Texture2D(wid, wid);
			newTexture.SetPixels32(bd);
			newTexture.wrapMode = TextureWrapMode.Repeat;
			newTexture.Apply();
			return newTexture;
		}

		public static Texture2D MakeMosaic3(int w) {
			var bd = new Color[w * w];
			for (int i=0; i<bd.Length; i++){
				bd[i] = new Color(128/255.0f, 128/255.0f, 128/255.0f);
				//bd[i] = new Color(1, 0, 0);
			}
			bd[0] = Color.white;
			bd[(w-1) + (w-1)*w] = Color.black;
			for (int x=1; x<w-1; x++) {
				bd[x] = new Color(224/255.0f, 224/255.0f, 224/255.0f);
				bd[x + 1] = Color.white;
				bd[x +  w * (w-1)] = Color.black;
			}
			for (int y=0; y<w-1; y++) {
				bd[y*w] = Color.white;
				bd[(w-1) + w*y] = Color.black;
			}
			Texture2D newtex = new Texture2D(w, w);
			newtex.SetPixels(bd);

			newtex.wrapMode = TextureWrapMode.Repeat;
			newtex.Apply();
			return newtex;
		}

public static Texture2D MakeAttenuationTexture(int w, float pow, float scale) {
	var bd = new Color[w * w];
	for (int i = 0; i < bd.Length; i++)
	{
		bd[i] = new Color(0,0,0,0);
	}
	/// 1.0 / (1.0 + 25.0*r*r)
	for (int x = 1; x < w - 1; x++)
	{
		for (int y = 1; y < w - 1; y++)
		{
			float actualX = 2.0f * ((float)x - ((float)w) / 2.0f) / (float)w;
			float actualY = 2.0f * ((float)y - ((float)w) / 2.0f) / (float)w;
			Vector2 vec = new Vector2(actualX, actualY);
			float distance = vec.magnitude;
			float attenuation = 1.0f / (1.0f + 25.0f * Mathf.Pow(distance, pow) * scale);
			Color c = new Color(attenuation, attenuation, attenuation, attenuation);
			bd[x + y * w] = c;
		}
	}
	Texture2D newtex = new Texture2D(w, w);
	newtex.SetPixels(bd);
	newtex.wrapMode = TextureWrapMode.Clamp;
	newtex.Apply();
	return newtex;
}
	}
}