using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public static class ExtensionMethods
{
	public static T Pop<T>(this List<T> theList)
	{
		var local = theList[theList.Count - 1];
		theList.RemoveAt(theList.Count - 1);
		return local;
	}
	
	public static void Push<T>(this List<T> theList, T item)
	{
		theList.Add(item);
	}
	
	public static void Shuffle<T>(this IList<T> list)  
	{  
	    System.Random rng = new System.Random();  
	    int n = list.Count;  
	    while (n > 1) {  
	        n--;  
	        int k = rng.Next(n + 1);  
	        T value = list[k];  
	        list[k] = list[n];  
	        list[n] = value;  
	    }  
	}
}
