using UnityEngine;
using System.Collections;

public class VectorUtil {
	public static bool RayCastInsideCone(float maxDist, Vector3 sourcePos, Quaternion sourceVec, GameObject target) {
		
		sourcePos.y = 0.0f;		
		Vector3 heading = target.transform.position - sourcePos;
		heading.y = 0.0f;
		float mag2 = heading.sqrMagnitude;
		if (mag2 < (maxDist*maxDist)) {
			heading.Normalize();
			Vector3 sightVec = sourceVec * new Vector3( 0, 1, 0 );
			sightVec.Normalize();
			if (Vector3.Dot(sightVec, heading) >= 0.85f) { //hardcoded 60 degree cone atm
				//in cone.. check ray
				RaycastHit hit;
				if (Physics.Raycast(sourcePos, heading, out hit, maxDist) && 
					target.GetInstanceID() == hit.collider.gameObject.GetInstanceID()) {
					return true;
				}
			}
		}
		return false;
	}
}
