using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour {

	public RaycastCharacterController mover;
	public Transform TargetTransform;

	public float AnimationScale = 100.0f;

	public tk2dAnimatedSprite Sprite = null;

	public Transform endText = null;

	// Use this for initialization
	void Start () {
		//Sprite = this.gameObject.GetComponent<tk2dAnimatedSprite>();

		Sprite.ClipFps = 0.1f;
	}
	
	// Update is called once per frame
	void LateUpdate () {
		if (TargetTransform != null) {
			//this.transform.position = TargetTransform.transform.position;
			var pos = TargetTransform.position;
			//pos.x = Mathf.RoundToInt( pos.x ) + 0.5f;
			//pos.y = Mathf.RoundToInt( pos.y ) + 0.5f;
			this.transform.position = pos;
			this.transform.rotation = TargetTransform.transform.rotation;
		}
	}

	bool ended = false;
	void Update() {
		if ( ended && Input.GetKeyUp( KeyCode.R ) ) {

			Application.LoadLevel( 0 );
		}

		if (Input.GetKeyUp(KeyCode.Escape)) {
			Application.Quit();
		}
		

		//float mag = this.rigidbody.velocity.magnitude;
		float mag = this.mover.Velocity.magnitude;
		if ( mag <= 0.1f ) {
			Sprite.PlayFromFrame( 0 );
		}
		//	Sprite.Play("walk");
		//} else {
		//Sprite.Play ("idle");
		//}
		Sprite.ClipFps = mag > 0 ? mag / AnimationScale : 0.01f;	
	}

	void OnTriggerEnter(Collider other) {
		if ( other.CompareTag( "dead" ) ) {
			Destroy( this.mover.gameObject );
			Destroy( this.gameObject );

			Baddie b = other.gameObject.GetComponent<Baddie>();
			if ( b != null ) {
				Destroy( b.gameObject );
			}

			Application.LoadLevel( 0 );
		} else if ( other.CompareTag( "win" ) ) {
			Debug.Log( "WINNER!" );
			endText.gameObject.SetActiveRecursively( true );

			Spawner s = (Spawner)FindObjectOfType( typeof( Spawner ) );
			Destroy( s.gameObject );
			ended = true;
			Time.timeScale = 0.0f;
		}
	}
}
